// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from marti_common_msgs:msg/UInt32Stamped.idl
// generated code does not contain a copyright notice
#include "marti_common_msgs/msg/detail/u_int32_stamped__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"

bool
marti_common_msgs__msg__UInt32Stamped__init(marti_common_msgs__msg__UInt32Stamped * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    marti_common_msgs__msg__UInt32Stamped__fini(msg);
    return false;
  }
  // value
  return true;
}

void
marti_common_msgs__msg__UInt32Stamped__fini(marti_common_msgs__msg__UInt32Stamped * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // value
}

bool
marti_common_msgs__msg__UInt32Stamped__are_equal(const marti_common_msgs__msg__UInt32Stamped * lhs, const marti_common_msgs__msg__UInt32Stamped * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // value
  if (lhs->value != rhs->value) {
    return false;
  }
  return true;
}

bool
marti_common_msgs__msg__UInt32Stamped__copy(
  const marti_common_msgs__msg__UInt32Stamped * input,
  marti_common_msgs__msg__UInt32Stamped * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // value
  output->value = input->value;
  return true;
}

marti_common_msgs__msg__UInt32Stamped *
marti_common_msgs__msg__UInt32Stamped__create()
{
  marti_common_msgs__msg__UInt32Stamped * msg = (marti_common_msgs__msg__UInt32Stamped *)malloc(sizeof(marti_common_msgs__msg__UInt32Stamped));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(marti_common_msgs__msg__UInt32Stamped));
  bool success = marti_common_msgs__msg__UInt32Stamped__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
marti_common_msgs__msg__UInt32Stamped__destroy(marti_common_msgs__msg__UInt32Stamped * msg)
{
  if (msg) {
    marti_common_msgs__msg__UInt32Stamped__fini(msg);
  }
  free(msg);
}


bool
marti_common_msgs__msg__UInt32Stamped__Sequence__init(marti_common_msgs__msg__UInt32Stamped__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  marti_common_msgs__msg__UInt32Stamped * data = NULL;
  if (size) {
    data = (marti_common_msgs__msg__UInt32Stamped *)calloc(size, sizeof(marti_common_msgs__msg__UInt32Stamped));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = marti_common_msgs__msg__UInt32Stamped__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        marti_common_msgs__msg__UInt32Stamped__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
marti_common_msgs__msg__UInt32Stamped__Sequence__fini(marti_common_msgs__msg__UInt32Stamped__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      marti_common_msgs__msg__UInt32Stamped__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

marti_common_msgs__msg__UInt32Stamped__Sequence *
marti_common_msgs__msg__UInt32Stamped__Sequence__create(size_t size)
{
  marti_common_msgs__msg__UInt32Stamped__Sequence * array = (marti_common_msgs__msg__UInt32Stamped__Sequence *)malloc(sizeof(marti_common_msgs__msg__UInt32Stamped__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = marti_common_msgs__msg__UInt32Stamped__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
marti_common_msgs__msg__UInt32Stamped__Sequence__destroy(marti_common_msgs__msg__UInt32Stamped__Sequence * array)
{
  if (array) {
    marti_common_msgs__msg__UInt32Stamped__Sequence__fini(array);
  }
  free(array);
}

bool
marti_common_msgs__msg__UInt32Stamped__Sequence__are_equal(const marti_common_msgs__msg__UInt32Stamped__Sequence * lhs, const marti_common_msgs__msg__UInt32Stamped__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!marti_common_msgs__msg__UInt32Stamped__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
marti_common_msgs__msg__UInt32Stamped__Sequence__copy(
  const marti_common_msgs__msg__UInt32Stamped__Sequence * input,
  marti_common_msgs__msg__UInt32Stamped__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(marti_common_msgs__msg__UInt32Stamped);
    marti_common_msgs__msg__UInt32Stamped * data =
      (marti_common_msgs__msg__UInt32Stamped *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!marti_common_msgs__msg__UInt32Stamped__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          marti_common_msgs__msg__UInt32Stamped__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!marti_common_msgs__msg__UInt32Stamped__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
